Index: trunk/examples/extended/electromagnetic/TestEm11/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/PhysicsListMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/PhysicsListMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.hh,v 1.2 2006/06/29 16:39:46 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.2 2006/06/29 16:39:49 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/PrimaryGeneratorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.hh,v 1.2 2006/06/29 16:39:52 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/RunAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/RunAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/RunAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.hh,v 1.3 2007/08/19 20:52:53 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/StepMax.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/StepMax.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/StepMax.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.hh,v 1.3 2006/06/29 16:39:57 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/StepMaxMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/StepMaxMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/StepMaxMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.hh,v 1.3 2006/06/29 16:40:00 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/SteppingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/SteppingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.hh,v 1.2 2006/06/29 16:40:03 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/SteppingVerbose.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/SteppingVerbose.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/SteppingVerbose.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.hh,v 1.2 2006/06/29 16:40:06 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/include/TrackingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/include/TrackingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/include/TrackingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TrackingAction.hh,v 1.2 2006/06/29 16:40:08 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/range.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/range.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/range.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: range.mac,v 1.4 2007/08/19 20:52:53 maire Exp $
+# $Id: range.mac,v 1.5 2009/09/22 14:20:31 maire Exp $
 #
 # Macro file for "TestEm11.cc"
@@ -13,7 +13,7 @@
 /testem/det/setSizeYZ 5 mm
 #
-/testem/phys/addPhysics  standard
-###/testem/phys/addPhysics  penelope
-###/testem/phys/addPhysics  livermore
+/testem/phys/addPhysics  local
+###/testem/phys/addPhysics  empenelope
+###/testem/phys/addPhysics  emlivermore
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm11/run01.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/run01.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/run01.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: run01.mac,v 1.5 2006/07/06 15:56:38 maire Exp $
+# $Id: run01.mac,v 1.6 2009/09/22 14:20:31 maire Exp $
 #
 # limit the step size from histo 1
@@ -10,6 +10,6 @@
 /testem/det/setSizeYZ 1 mm
 #
-/testem/phys/addPhysics  standard	# em physics
-###/testem/phys/addPhysics  penelope  	# em physics 
+/testem/phys/addPhysics  local	# em physics
+###/testem/phys/addPhysics  empenelope  	# em physics 
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm11/run02.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/run02.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/run02.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: run02.mac,v 1.4 2006/10/26 10:18:59 maire Exp $
+# $Id: run02.mac,v 1.5 2009/09/22 14:20:31 maire Exp $
 #
 # limit the step size by geometry
@@ -11,6 +11,6 @@
 /testem/det/setNbOfLayers 100
 #
-/testem/phys/addPhysics  standard	# em physics
-###/testem/phys/addPhysics  penelope  	# em physics 
+/testem/phys/addPhysics  local	# em physics
+###/testem/phys/addPhysics  empenelope  	# em physics 
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm11/sandia.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/sandia.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/sandia.mac	(revision 1230)
@@ -1,7 +1,8 @@
-# $Id: sandia.mac,v 1.1 2007/08/19 20:52:53 maire Exp $
+# $Id: sandia.mac,v 1.9 2009/09/22 14:20:31 maire Exp $
 #
 # limit the step size from histo 8
 #
-# G.J.Lockwood et al. Sandia report SAND79-0414.UC-34a, February 1987
+# G.J.Lockwood et al.
+#     Sandia report SAND79-0414.UC-34a, February 1987
 # O.Kadri et al. NIM B 258 (2007) 381
 #
@@ -10,19 +11,21 @@
 #
 /testem/det/setMat G4_Al
+###/testem/det/setMat G4_Mo
 ###/testem/det/setMat G4_Ta
 /testem/det/setSizeX  1 cm
 /testem/det/setSizeYZ 1 cm
 #
-/testem/phys/addPhysics  standard	# em physics
+/testem/phys/addPhysics  local	# em physics
 #
 /run/initialize
 #
 /gun/particle e-
-/gun/energy 500 keV
+/gun/energy 314 keV
 #
-/testem/histo/setFileType hbook
-/testem/histo/setFileName Al.500keV
+###/testem/histo/setFileType hbook
+/testem/histo/setFileType root
+/testem/histo/setFileName sandia/Al.314keV
 /testem/histo/setHisto 8 100 0.  1.0 none	#normalized Edep profile
-###/testem/histo/setHisto 8 100 0.  0.5 none
+###/testem/histo/setHisto 8 100 0.  0.5 none	#for Ta
 #
 /testem/event/printModulo 10000
Index: trunk/examples/extended/electromagnetic/TestEm11/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/DetectorConstruction.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: DetectorConstruction.cc,v 1.8 2007/11/07 17:22:16 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: DetectorConstruction.cc,v 1.9 2009/11/16 15:09:10 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 
 //
@@ -91,4 +91,5 @@
   man->FindOrBuildMaterial("G4_Si", isotopes);
   man->FindOrBuildMaterial("G4_Fe", isotopes);
+  man->FindOrBuildMaterial("G4_Cu", isotopes);  
   man->FindOrBuildMaterial("G4_Ge", isotopes);
   man->FindOrBuildMaterial("G4_Mo", isotopes);
Index: trunk/examples/extended/electromagnetic/TestEm11/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.2 2006/06/29 16:40:12 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.2 2006/06/29 16:40:15 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.2 2006/06/29 16:40:18 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.6 2007/11/07 17:22:16 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoManager.cc,v 1.10 2008/09/22 15:11:34 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -54,6 +54,6 @@
  
   fileName[0] = "dummy";
-  fileType    = "hbook";
-  fileOption  = "--noErrors uncompress";  
+  fileType    = "root";
+  fileOption  = "--noErrors export=root uncompress";  
   // histograms
   for (G4int k=0; k<MaxHisto; k++) {
@@ -223,6 +223,6 @@
 {
  if (ih > MaxHisto) {
-    G4cout << "---> warning from HistoManager::RemoveHisto() : histo " << ih
-           << "does not exist" << G4endl;
+    G4cout << "---> warning from HistoManager::Scale() : histo " << ih
+           << "does not exist  (fac = " << fac << ")"  << G4endl;
     return;
   }
@@ -236,5 +236,5 @@
 void HistoManager::PrintHisto(G4int ih)
 {
- if (ih < MaxHisto) ascii[ih] = true;
+ if (ih < MaxHisto) { ascii[ih] = true; ascii[0] = true; }
  else
     G4cout << "---> warning from HistoManager::PrintHisto() : histo " << ih
@@ -249,4 +249,6 @@
 {
 #ifdef G4ANALYSIS_USE
+
+ if (!ascii[0]) return;
  
  G4String name = fileName[0] + ".ascii";
@@ -262,5 +264,6 @@
       for (G4int iBin=0; iBin<Nbins[ih]; ++iBin) {
          File << "  " << iBin << "\t" 
-              << histo[ih]->binMean(iBin) << "\t"
+              << 0.5*(histo[ih]->axis().binLowerEdge(iBin) +
+	              histo[ih]->axis().binUpperEdge(iBin)) << "\t"	      
 	      << histo[ih]->binHeight(iBin) 
 	      << G4endl;
Index: trunk/examples/extended/electromagnetic/TestEm11/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/HistoMessenger.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoMessenger.cc,v 1.5 2007/11/07 17:22:16 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoMessenger.cc,v 1.6 2008/01/11 13:01:57 jjacquem Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -56,4 +56,7 @@
   typeCmd->SetGuidance("set histograms file type: hbook, root, XML");
   typeCmd->SetCandidates("hbook root XML");
+
+  optionCmd = new G4UIcmdWithAString("/testem/histo/setFileOption",this);
+  optionCmd->SetGuidance("set option for the histograms file");
 
   histoCmd = new G4UIcommand("/testem/histo/setHisto",this);
@@ -112,4 +115,5 @@
   delete factoryCmd;
   delete histoDir;
+  delete optionCmd;
 }
 
@@ -123,4 +127,7 @@
   if (command == typeCmd)
     histoManager->SetFileType(newValues);
+
+  if (command == optionCmd)
+    histoManager->SetFileOption(newValues);
 
   if (command == histoCmd)
Index: trunk/examples/extended/electromagnetic/TestEm11/src/PhysListEmStandard.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/PhysListEmStandard.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/PhysListEmStandard.cc	(revision 1230)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: PhysListEmStandard.cc,v 1.3 2006/06/29 16:40:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: PhysListEmStandard.cc,v 1.11 2009/11/16 15:09:10 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -39,16 +38,26 @@
 #include "G4PhotoElectricEffect.hh"
 
-#include "G4MultipleScattering.hh"
-
+#include "G4eMultipleScattering.hh"
+#include "G4UrbanMscModel93.hh"
 #include "G4eIonisation.hh"
 #include "G4eBremsstrahlung.hh"
 #include "G4eplusAnnihilation.hh"
 
+#include "G4MuMultipleScattering.hh"
 #include "G4MuIonisation.hh"
 #include "G4MuBremsstrahlung.hh"
 #include "G4MuPairProduction.hh"
 
+#include "G4hMultipleScattering.hh"
 #include "G4hIonisation.hh"
+#include "G4hBremsstrahlung.hh"
+#include "G4hPairProduction.hh"
+
 #include "G4ionIonisation.hh"
+#include "G4IonParametrisedLossModel.hh"
+#include "G4NuclearStopping.hh"
+
+#include "G4EmProcessOptions.hh"
+#include "G4MscStepLimitType.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -68,5 +77,6 @@
 {
   // Add standard EM Processes
-  
+  //
+
   theParticleIterator->reset();
   while( (*theParticleIterator)() ){
@@ -76,5 +86,5 @@
      
     if (particleName == "gamma") {
-      // gamma         
+      // gamma
       pmanager->AddDiscreteProcess(new G4PhotoElectricEffect);
       pmanager->AddDiscreteProcess(new G4ComptonScattering);
@@ -83,35 +93,90 @@
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
-      	    
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);      
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
+	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
-      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1,4);
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);            
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4eplusAnnihilation,    0,-1, 4);
             
-    } else if( particleName == "mu+" || 
+    } else if (particleName == "mu+" || 
                particleName == "mu-"    ) {
       //muon  
-      pmanager->AddProcess(new G4MultipleScattering,-1, 1,1);
-      pmanager->AddProcess(new G4MuIonisation,      -1, 2,2);
-      pmanager->AddProcess(new G4MuBremsstrahlung,  -1, 3,3);
-      pmanager->AddProcess(new G4MuPairProduction,  -1, 4,4);       
+      pmanager->AddProcess(new G4MuMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4MuIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4MuBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4MuPairProduction,     -1, 4, 4);
+             
+    } else if( particleName == "proton" ||
+               particleName == "pi-" ||
+               particleName == "pi+"    ) {
+      //proton  
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4hBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4hPairProduction,     -1, 4, 4);       
      
-    } else if( particleName == "GenericIon" ) { 
-      pmanager->AddProcess(new G4MultipleScattering,-1, 1,1);
-      pmanager->AddProcess(new G4ionIonisation,     -1, 2,2);
-
+    } else if( particleName == "alpha" || 
+	       particleName == "He3"    ) {
+      //alpha 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4ionIonisation,       -1, 2, 2);
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);
+            
+    } else if( particleName == "GenericIon" ) {
+      //Ions 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      G4ionIonisation* ionIoni = new G4ionIonisation();
+      ionIoni->SetEmModel(new G4IonParametrisedLossModel());
+      pmanager->AddProcess(ionIoni,                   -1, 2, 2);      
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);      
+      
     } else if ((!particle->IsShortLived()) &&
 	       (particle->GetPDGCharge() != 0.0) && 
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4MultipleScattering,-1,1,1);
-      pmanager->AddProcess(new G4hIonisation,       -1,2,2);
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
     }
   }
+
+  // Em options
+  //
+  // Main options and setting parameters are shown here.
+  // Several of them have default values.
+  //
+  G4EmProcessOptions emOptions;
+  
+  //physics tables
+  //
+  emOptions.SetMinEnergy(100*eV);	//default    
+  emOptions.SetMaxEnergy(100*TeV);	//default  
+  emOptions.SetDEDXBinning(12*20);	//default=12*7
+  emOptions.SetLambdaBinning(12*20);	//default=12*7
+  emOptions.SetSplineFlag(true);	//default
+      
+  //multiple coulomb scattering
+  //
+  emOptions.SetMscStepLimitation(fUseDistanceToBoundary);  //default=fUseSafety
+  emOptions.SetMscRangeFactor(0.04);	//default
+  emOptions.SetMscGeomFactor (2.5);	//default       
+  emOptions.SetSkin(3.);		//default
+      
+  //energy loss
+  //
+  emOptions.SetStepFunction(0.2, 100*um);	//default=(0.2, 1*mm)   
+  emOptions.SetLinearLossLimit(1.e-2);		//default
+   
+  //ionization
+  //
+  emOptions.SetSubCutoff(false);	//default
 }
 
Index: trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsList.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsList.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsList.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysicsList.cc,v 1.5 2006/10/26 10:18:59 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsList.cc,v 1.7 2009/09/22 14:20:31 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -34,6 +34,11 @@
 
 #include "PhysListEmStandard.hh"
-#include "PhysListEmLivermore.hh"
-#include "PhysListEmPenelope.hh"
+
+#include "G4EmStandardPhysics.hh"
+#include "G4EmStandardPhysics_option1.hh"
+#include "G4EmStandardPhysics_option2.hh"
+#include "G4EmStandardPhysics_option3.hh"
+#include "G4EmLivermorePhysics.hh"
+#include "G4EmPenelopePhysics.hh"
 
 #include "G4LossTableManager.hh"
@@ -57,5 +62,5 @@
 
   // EM physics
-  emPhysicsList = new PhysListEmStandard(emName = "standard");
+  emPhysicsList = new PhysListEmStandard(emName = "local");
 
 }
@@ -186,5 +191,6 @@
   G4EmProcessOptions emOptions;
   emOptions.SetBuildCSDARange(true);
-  
+  emOptions.SetDEDXBinningForCSDARange(8*20);
+    
   // decay process
   //
@@ -206,21 +212,43 @@
   if (name == emName) return;
 
-  if (name == "standard") {
+  if (name == "local") {
 
     emName = name;
     delete emPhysicsList;
     emPhysicsList = new PhysListEmStandard(name);
+
+  } else if (name == "emstandard_opt0") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics();
     
-  } else if (name == "livermore") {
-
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmLivermore(name);
+  } else if (name == "emstandard_opt1") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option1();
+
+  } else if (name == "emstandard_opt2") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option2();
+        
+  } else if (name == "emstandard_opt3") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmStandardPhysics_option3();
+            
+  } else if (name == "emlivermore") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmLivermorePhysics();
     
-  } else if (name == "penelope") {
-
-    emName = name;
-    delete emPhysicsList;
-    emPhysicsList = new PhysListEmPenelope(name);
+  } else if (name == "empenelope") {
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new G4EmPenelopePhysics();
         
   } else {
Index: trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsListMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/PhysicsListMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.cc,v 1.2 2006/06/29 16:40:38 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.2 2006/06/29 16:40:40 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/PrimaryGeneratorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorMessenger.cc,v 1.2 2006/06/29 16:40:43 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/RunAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/RunAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/RunAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.cc,v 1.7 2007/08/19 20:52:53 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/StepMax.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/StepMax.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/StepMax.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.cc,v 1.3 2006/06/29 16:40:47 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/StepMaxMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/StepMaxMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/StepMaxMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.cc,v 1.3 2006/06/29 16:40:53 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/SteppingAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/SteppingAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/SteppingAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.cc,v 1.5 2007/08/19 20:52:53 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/SteppingVerbose.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/SteppingVerbose.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/SteppingVerbose.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.cc,v 1.2 2006/06/29 16:41:54 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/src/TrackingAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/src/TrackingAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/src/TrackingAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TrackingAction.cc,v 1.2 2006/06/29 16:41:56 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm11/water.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm11/water.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm11/water.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: water.mac,v 1.4 2006/09/18 17:26:20 maire Exp $
+# $Id: water.mac,v 1.5 2009/09/22 14:20:31 maire Exp $
 #
 # no constraint on tracking step
@@ -10,6 +10,5 @@
 /testem/det/setSizeYZ 3 cm
 #
-/testem/phys/addPhysics  standard	# em physics
-###/testem/phys/addPhysics  g4v52  	# em physics 
+/testem/phys/addPhysics  local	# em physics
 #
 /run/initialize
Index: trunk/examples/extended/electromagnetic/TestEm12/GNUmakefile
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/GNUmakefile	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/GNUmakefile	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.2 2006/10/25 17:27:01 maire Exp $
+# $Id: GNUmakefile,v 1.5 2008/06/11 22:40:49 maire Exp $
 # --------------------------------------------------------------
 # GNUmakefile for examples module.  Gabriele Cosmo, 06/04/98.
@@ -17,15 +17,5 @@
 #### G4ANALYSIS_USE := true
 
-ifdef G4ANALYSIS_USE
-  CPPFLAGS += -DG4ANALYSIS_USE
-endif
-
 include $(G4INSTALL)/config/architecture.gmk
-
-ifdef G4ANALYSIS_USE
-  # for the aida-config command see the README file
-  CPPFLAGS += `aida-config --include`
-  LOADLIBS += `aida-config --lib`
-endif
 
 include $(G4INSTALL)/config/binmake.gmk
Index: trunk/examples/extended/electromagnetic/TestEm12/TestEm12.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm12/TestEm12.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm12/TestEm12.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TestEm12.cc,v 1.4 2006/06/29 16:41:58 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
